#include <vector>
#include <iostream>
#include "text.h"

using namespace std;

const size_t SCREEN_WIDTH = 80;
const size_t MAX_ASTERISK = SCREEN_WIDTH - 4;

void show_histogram_text(vector<size_t> &bins, size_t bin_count){
    size_t maxbin = bins[0];
    for (size_t i=1; i < bin_count; i++){
        if (maxbin < bins[i]){
            maxbin = bins[i];
        }
    }

    if (maxbin <= MAX_ASTERISK){
        for (size_t i = 0; i < bin_count; i++) {
            cout.width(4);
            cout << bins[i] << "|";
            for (size_t j = 0; j < bins[i]; j++) {
                cout << "*";
            }
            cout << endl;
        }
    } else {
        for (size_t i = 0; i < bin_count; i++) {
            cout.width(4);
            cout << bins[i] << "|";
            size_t height = static_cast<size_t>(MAX_ASTERISK * (static_cast<double>(bins[i]) / maxbin));
            for (size_t j = 0; j < height; j++) {
                cout << "*";
            }
            cout << endl;
        }
    }
}
